

#--- Atari ---
# gcc options
CC		= m68k-atari-mint-gcc
CXX		= m68k-atari-mint-g++
LINK	= m68k-atari-mint-g++
STRIP	= m68k-atari-mint-strip


LIBINCPATHS = -I3rdparty/
COMPILERDEFS = \
				-D__ATARI__ \
				-D_GNU_SOURCE \
				-DCOLOUR_ROUNDING_SCHEME=1

CODEGENFLAGS = $(TARGETFLAGS) -O3 -fomit-frame-pointer -fno-strict-aliasing 
#CODEGENFLAGS = $(TARGETFLAGS) -g -O0

CFLAGS	= $(CODEGENFLAGS) $(COMPILERDEFS) $(LIBINCPATHS) -Wall
CXXFLAGS = $(CODEGENFLAGS) $(COMPILERDEFS) $(LIBINCPATHS) -Wall -Wno-reorder
LDFLAGS = #-Wl,--stack,1048576

headers	= 	common.h

OBJS = 		\
			common.o \
			imagepkg.o \
			pcsimage.o \
			laceunit.o \
			ditherunit.o \
			errorunit.o \
			reduceunit.o \
			diagnosticunit.o \
			reduceunit_sampling.o \
			reduceunit_analytical.o \
			reduceunit_som.o \
			pcsimage_std_sgl.o \
			pcsimage_std_dual.o \
			pcsimage_std_tri.o \
			pcsimage_std_quad.o \
			pcsfile.o \
			pcspct.o \
			pcsdpt.o \
			convert.o \
			main.o

# rule to build everything
all: $(PGM)

# rule to build/link application
$(PGM):	$(OBJS) Makefile.shared.mint Makefile.68k.mint Makefile.030.mint Makefile.0x0.mint
	$(LINK) $(LIBSEARCH) -o $(PGM) $(OBJS) $(LIBS) $(LDFLAGS)
	$(STRIP) $(PGM)
	cp $(PGM) distro/TOS/.

# rule to compile C files
%.o: %.c
	$(CC) -c $(CFLAGS) -o $@ $<

# rule to compile C++ files
%.o: %.cpp
	$(CXX) -c $(CXXFLAGS) -o $@ $<

# rules to convert binary tables back to C source (optional)
#pcsdpt.c: PCS.DPT
#	cincbin PCS.DPT /opcsdpt.c /w70 /s2 /nDPT_PCS
#pcspct.c: PCS.PCT
#	cincbin PCS.PCT /opcspct.c /w100 /s1 /nPCT_PCS

#%.S: %.c
#	$(CC) -S $(CFLAGS) -o $@ $<
#
#%.S: %.cpp
#	$(CXX) -S $(CXXFLAGS) -o $@ $<

clean:
	-rm -f $(OBJS)
