// ---------------------------------------------------------------------------------------------------------------------
//	PhotoChrome v6.xx - Atari ST interlaced image reduction framework
//	1991-2016 Douglas Little (d.m.l)
// ---------------------------------------------------------------------------------------------------------------------
//	special thanks to:
//		evil@DHS, RA/PDX, Troed/SYNC for help testing and input on improvements
// ---------------------------------------------------------------------------------------------------------------------

#ifndef lcg_h_
#define lcg_h_

// --------------------------------------------------------------------
// object representing LCG/PRNG state
// --------------------------------------------------------------------

class LCG
{
	unsigned long state_;
	
public:
	
	LCG(unsigned long _seed)
		: state_(_seed)
	{
	}
	
	void reset(unsigned long _seed)
	{
		state_ = _seed;
	}
	
	inline unsigned short lcg_sample()
	{
		state_ = (state_ * 19387) + 27791;
		return (state_ >> 15) & 255;
	}
	
	inline unsigned long lcg_sample24()
	{
		state_ = (state_ * 19387) + 27791;
		return (state_ >> 8) & 0xffffff;
	}	
};

// --------------------------------------------------------------------

#endif // lcg_h_
