// ---------------------------------------------------------------------------------------------------------------------
//	PhotoChrome v6.xx - Atari ST interlaced image reduction framework
//	1991-2016 Douglas Little (d.m.l)
// ---------------------------------------------------------------------------------------------------------------------
//	special thanks to:
//		evil@DHS, RA/PDX, Troed/SYNC for help testing and input on improvements
// ---------------------------------------------------------------------------------------------------------------------

// ====================================================================
// 	generic reduction unit for PCS files
// ====================================================================
//	note: this bit is volatile - to be significantly refactored!
// ====================================================================

#include "common.h"
#include "config.h"

#if defined(__ATARI__) || defined(__MINGW32__)
#include "FreeImage.3.15.3.h"
#else
#include "FreeImage.3.15.4.h"
#endif

#include "imagepkg.h"
#include "pcsimage_std_sgl.h"

extern Arguments g_allargs;

// --------------------------------------------------------------------

PCSImage_std_sgl::PCSImage_std_sgl(const char* const _name, int _w, int _h, int _d, int _colours, int _planes, int _np, int _ns)
	: PCSImage(_name, _w, _h, _d, _colours, _planes, _np, _ns)
{

	framebuffer_words_ = (((display_width_+15) >> 4) * display_planes_) * display_height_;
	//palettebuffer_words_ = 16*((3 * (display_height_-1)) + 1);
	palettebuffer_words_ = palettebuffer_stride_ * display_height_;
	
	fields_ = 1;

	for (int f = 0; f < fields_; ++f)
	{
		bitmaps_[f] = new word_t[framebuffer_words_ + 4];
		if (!bitmaps_[f]) { printf("error - could not allocate memory for framebuffer!\n"); getchar(); exit(1); }
		palettes_[f] = new word_t[palettebuffer_words_ + 4];
		if (!palettes_[f]) { printf("error - could not allocate memory for palettebuffer!\n"); getchar(); exit(1); }
	}
}	

// --------------------------------------------------------------------

